package com.winhc.dataworks.flow.touch;

import com.aliyuncs.dataworks_public.model.v20180601.CreateManualDagResponse;
import com.google.gson.JsonObject;
import com.helospark.lightdi.LightDi;
import com.helospark.lightdi.LightDiContext;
import com.helospark.lightdi.annotation.Autowired;
import com.helospark.lightdi.annotation.Service;
import com.winhc.dataworks.flow.touch.bean.TaskParam;
import com.winhc.dataworks.flow.touch.service.TouchService;
import com.winhc.dataworks.flow.touch.utils.JsonUtils;
import com.winhc.dataworks.flow.touch.utils.YmlUtil;
import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.util.*;

/**
 * @Author: XuJiakai
 * @Date: 2020/6/22 10:45
 * @Description:
 */
@Slf4j
@Service
public class Main {
    @Autowired
    private TouchService touchService;


    public static void main(String[] args) {
        LightDiContext context = LightDi.initContextByPackage(Main.class.getPackage().getName());
        Main bean = context.getBean(Main.class);
        bean.start();
//        bean.query();
    }

    private void start() {
        log.info("start");
        Map<String, String> map = new HashMap<>();
        Map<String,Object> mapTable=YmlUtil.getResMap("table");
        for(Map.Entry<String, Object> entry : mapTable.entrySet()){
            String tableName = entry.getKey();
            Object mapValue = entry.getValue();
            JsonObject dagPara = new JsonObject();
            dagPara.addProperty("PROJECT","winhc_eci");//业务流程参数。
            JsonObject nodePara = new JsonObject();
            nodePara.addProperty("700003366062",mapValue.toString().replaceAll(":","="));
            CreateManualDagResponse touch = touchService.triggerWithParam("winhc_eci","IncDataFlow","2020-06-05",dagPara.toString(),nodePara.toString());
            System.out.println(JsonUtils.jsonObjToString(touch));
        }

        /*List<String> strings = Arrays.asList("test1=a1"
                , "test2=a2"
                , "test3=a3");
        map.put("700003342843", String.join(" ", strings));


        TaskParam build = TaskParam.builder().projectName("winhc_test")
                .flowName("test_touch")
                .bizDate("2020-06-04")
                .nodeParam(map).build();
        CreateManualDagResponse touch = touchService.touch(build);
        System.out.println(JsonUtils.jsonObjToString(touch));*/
    }

    private void query(){
        touchService.query("winhc_test",700134013109L);
    }
}
